//------------------------------------------------------------------------
//
// Author      : Jan Horn
// Email       : jhorn@global.co.za
// Website     : http://www.sulaco.co.za
//               http://home.global.co.za/~jhorn
// Date        : 23 February 2002
// Version     : 1.0
// Description : Delphi Forms Application Template
//
//------------------------------------------------------------------------
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, OpenGL,
  ExtCtrls, StdCtrls,math;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label4: TLabel;
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Panel1Resize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    rc : HGLRC;    // Rendering Context
    dc  : HDC;     // Device Context
    ElapsedTime, AppStart, LastTime : DWord;  // Timing variables
    procedure glDraw;
    procedure Idle(Sender: TObject; var Done: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

var keys:array[0..65535] of boolean;

type TCamera=record
             x,y,z:single;
             dist:single;
             phi:single;
             end;

type TPlayer=record
              x,y,z:single;
              bx,by,bz:single;

              dx,dy,dz:single;

              carRad:single;
              carLen:single;

              phi:single;
              alpha:single;
              beta:single;
              speed:single;
              power:single;

              up:boolean;
              down:boolean;
              left:boolean;
              right:boolean;
              fire:boolean;
              jump:boolean;
             end;

var Camera:TCamera;
var Players:array of TPlayer;

var RotSpeed:single;
var SpeedConst:single;

var t1,t2,dt:integer;




procedure wheel;

implementation

{$R *.DFM}

{------------------------------------------------------------------}
{  Function to draw the actual scene                               }
{------------------------------------------------------------------}
procedure TForm1.glDraw();
var i:integer;
var tx,ty,tz,tlen:single;
var tmp:single;
begin

 t1:=t2;
 t2:=GetTickCount;
 if t2>t1 then dt:=t2-t1;
 RotSpeed:=dt*0.015;
 SpeedConst:=dt*0.0005;


 Players[0].up:=Keys[vk_up];
 Players[0].down:=Keys[vk_down];
 Players[0].left:=Keys[vk_left];
 Players[0].right:=Keys[vk_right];
 Players[0].fire:=Keys[vk_space];
 Players[0].jump:=Keys[vk_return];

 for i := 0 to length(Players) - 1 do
 With Players[i] do
  begin

   dx:=speed*sin(Phi*Pi/180);
   dz:=speed*cos(Phi*Pi/180);

   x:=x+dx*speedConst;
   y:=y+dy*speedConst;
   z:=z+dz*speedConst;


   //v=wR, w=v/R
   tmp:=sqrt(dx*dx+dz*dz)*speedConst;
   tmp:=tmp/12;
   alpha:=alpha+tmp*sign(speed);
   if alpha>Pi*2 then alpha:=alpha-Pi*2;




   if left then phi:=phi+RotSpeed;
   if right then phi:=phi-RotSpeed;

   if up then speed:=speed+SpeedConst;
   if down then speed:=speed-SpeedConst;

   if speed>13 then speed:=13;
   if speed<-3 then speed:=-3;

   tx:=bx-x;
   ty:=by-y;
   tz:=bz-z;
   tlen:=sqrt(tx*tx+ty*ty+tz*tz);

   tx:=tx/tlen;
   ty:=ty/tlen;
   tz:=tz/tlen;


   if tz<>0 then
   beta:=arctan(tx/tz) else
   beta:=0;



   bx:=x+tx*carLen;
   by:=y+ty*carLen;
   bz:=z+tz*carLen;

//   fly:=fly*0.5;
   if jump then
    begin
     dy:=30;
     y:=1;
    end;
   Keys[vk_return]:=false;

   if y>0 then
   dy:=dy-10*speedConst;
   if y<0 then dy:=0;

   if y<=0 then
   if by>0 then
   by:=by-5*speedConst;








  end;


  Camera.Phi:=0;
  Camera.Dist:=50;

  Camera.x:=Players[0].x+Camera.dist*sin(Camera.Phi*Pi/180);
  Camera.y:=25;
  Camera.z:=Players[0].z+Camera.dist*cos(Camera.Phi*Pi/180);

  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);    // Clear The Screen And The Depth Buffer
  glLoadIdentity();                                       // Reset The View

  gluLookAt(Camera.X,Camera.Y,Camera.Z,
            Players[0].X,Players[0].Y,Players[0].Z,
            0,1,0);



  // setka
  glColor3f(0.5,0.5,0.5);
  glBegin(GL_LINES);
   for i := 0 to 10 do
    begin
     glVertex(-50,0,-50+i*10); glVertex(50,0,-50+i*10);
     glVertex(-50+i*10,0,-50); glVertex(-50+i*10,0,50);
    end;
  glEnd();



  glPushMatrix;

  // treugolnik Player
  with Players[0] do
   begin
    glTranslatef(X,Y,Z);
    glRotatef(Phi,0,1,0);
    glRotatef(Alpha*180/Pi,1,0,0);
    wheel;    
   end;


  // sistema koordinat
{  glColor3f(1,1,1);
  glBegin(GL_LINES);
  glVertex(0,1, 0); glVertex(5,1, 0); // X
  glVertex(0,1, 0); glVertex(0,5, 0); // Y
  glVertex(0,1, 0); glVertex(0,1, 5); // Z
  glEnd();}

  glPopMatrix;

  with Players[0] do
   begin
    glTranslatef(bX,bY,bZ);

    glRotatef(Beta*180/Pi,0,1,0);


    glRotatef(Alpha*180/Pi,1,0,0);
    wheel;
   end;



//  glrotatef(gettickcount/10,0,1,0);





end;


procedure wheel;
var i:integer;
begin

glRotatef(90,0,1,0);

   glBegin(gl_quads);
  for i := 0 to 17 do
   begin
    glColor3f(0.4,0.4,0.4);
    glVertex3f(12*sin(20*i*Pi/180),
               12*cos(20*i*Pi/180),
               4);

    glVertex3f(12*sin(20*(i+1)*Pi/180),
               12*cos(20*(i+1)*Pi/180),
               4);

    glColor3f(0.2,0.2,0.2);
    glVertex3f(6*sin(20*(i+1)*Pi/180),
               6*cos(20*(i+1)*Pi/180),
               4);

    glVertex3f(6*sin(20*(i)*Pi/180),
               6*cos(20*(i)*Pi/180),
               4);


    glColor3f(0.4,0.4,0.4);
    glVertex3f(12*sin(20*i*Pi/180),
               12*cos(20*i*Pi/180),
               -4);

    glVertex3f(12*sin(20*(i+1)*Pi/180),
               12*cos(20*(i+1)*Pi/180),
               -4);

    glColor3f(0.2,0.2,0.2);
    glVertex3f(6*sin(20*(i+1)*Pi/180),
               6*cos(20*(i+1)*Pi/180),
               -4);

    glVertex3f(6*sin(20*(i)*Pi/180),
               6*cos(20*(i)*Pi/180),
               -4);




    if i mod 2=0 then
    glColor3f(0.15,0.15,0.15) else
    glColor3f(0.25,0.25,0.25);
    glVertex3f(12*sin(20*i*Pi/180),
               12*cos(20*i*Pi/180),
               4);

    glVertex3f(12*sin(20*(i+1)*Pi/180),
               12*cos(20*(i+1)*Pi/180),
               4);



    glVertex3f(12*sin(20*(i+1)*Pi/180),
               12*cos(20*(i+1)*Pi/180),
               -4);

    glVertex3f(12*sin(20*(i)*Pi/180),
               12*cos(20*(i)*Pi/180),
               -4);


    glColor3f(0.0,0.0,0.0);
    glVertex3f(7*sin(20*i*Pi/180),
               7*cos(20*i*Pi/180),
               4);

    glVertex3f(7*sin(20*(i+1)*Pi/180),
               7*cos(20*(i+1)*Pi/180),
               4);

    glColor3f(1.0,0.2,0.2);
    glVertex3f(1*sin(20*(i+1)*Pi/180),
               1*cos(20*(i+1)*Pi/180),
               6);

    glVertex3f(1*sin(20*(i)*Pi/180),
               1*cos(20*(i)*Pi/180),
               6);


    glColor3f(0.0,0.0,0.0);
    glVertex3f(7*sin(20*i*Pi/180),
               7*cos(20*i*Pi/180),
               -4);

    glVertex3f(7*sin(20*(i+1)*Pi/180),
               7*cos(20*(i+1)*Pi/180),
               -4);

    glColor3f(1.0,0.2,0.2);
    glVertex3f(1*sin(20*(i+1)*Pi/180),
               1*cos(20*(i+1)*Pi/180),
               -6);

    glVertex3f(1*sin(20*(i)*Pi/180),
               1*cos(20*(i)*Pi/180),
               -6);

    glColor3f(1,1,0);
    glVertex3f(-1,
               -1,
               -6);

    glVertex3f(1,
               -1,
               -6);

    glVertex3f(1,
               1,
               -6);

    glVertex3f(-1,
               1,
               -6);

glColor3f(1,1,0);
    glVertex3f(-1,
               -1,
               6);

    glVertex3f(1,
               -1,
               6);

    glVertex3f(1,
               1,
               6);

    glVertex3f(-1,
               1,
               6);


   end;
   glEnd();

end;


{------------------------------------------------------------------}
{  Initialise OpenGL                                               }
{------------------------------------------------------------------}
procedure glInit();
begin
  glClearColor(0.0, 0.0, 0.0, 0.0); 	   // Black Background
  glShadeModel(GL_SMOOTH);                 // Enables Smooth Color Shading
  glClearDepth(1.0);                       // Depth Buffer Setup
  glEnable(GL_DEPTH_TEST);                 // Enable Depth Buffer
//  glDepthFunc(GL_LESS);		           // The Type Of Depth Test To Do
  glDepthFunc(GL_LEQUAL);
  glDisable(GL_CULL_FACE);

  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //Realy Nice perspective calculations
end;


{------------------------------------------------------------------}
{  Create the form and initialist openGL                           }
{------------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
var pfd : TPIXELFORMATDESCRIPTOR;
    pf  : Integer;
begin
  // OpenGL initialisieren
  dc:=GetDC(Panel1.Handle);

  // PixelFormat
  pfd.nSize:=sizeof(pfd);
  pfd.nVersion:=1;
  pfd.dwFlags:=PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or 0;
  pfd.iPixelType:=PFD_TYPE_RGBA;      // PFD_TYPE_RGBA or PFD_TYPEINDEX
  pfd.cColorBits:=32;

  pf :=ChoosePixelFormat(dc, @pfd);   // Returns format that most closely matches above pixel format
  SetPixelFormat(dc, pf, @pfd);

  rc :=wglCreateContext(dc);    // Rendering Context = window-glCreateContext
  wglMakeCurrent(dc,rc);        // Make the DC (Form1) the rendering Context

  // Initialist GL environment variables
  glInit;
  Panel1Resize(sender);    // sets up the perspective
  AppStart :=GetTickCount();

  // when the app has spare time, render the GL scene
  Application.OnIdle := Idle;

  setlength(Players,1);
  Players[0].x:=0;
  Players[0].y:=0;
  Players[0].z:=0;
  Players[0].bx:=1;
  Players[0].by:=1;
  Players[0].bz:=1;
  Players[0].dx:=0;
  Players[0].dy:=0;
  Players[0].dz:=0;
  Players[0].carRad:=5;
  Players[0].carLen:=24;

  Players[0].phi:=0;
  Players[0].alpha:=0;
  Players[0].beta:=0;
  Players[0].speed:=0;
  Players[0].power:=100;

  Players[0].up:=false;
  Players[0].down:=false;
  Players[0].left:=false;
  Players[0].right:=false;
  Players[0].fire:=false;

  Camera.x:=0;
  Camera.y:=0;
  Camera.z:=0;
  Camera.dist:=50;
  Camera.phi:=0;



  fillchar(keys,65536,0);
end;


{------------------------------------------------------------------}
{  Release rendering context when form gets detroyed               }
{------------------------------------------------------------------}
procedure TForm1.FormDestroy(Sender: TObject);
begin
  wglMakeCurrent(0,0);
  wglDeleteContext(rc);
end;


{------------------------------------------------------------------}
{  Application onIdle event                                        }
{------------------------------------------------------------------}
procedure TForm1.Idle(Sender: TObject; var Done: Boolean);
begin
  Done := FALSE;

  LastTime :=ElapsedTime;
  ElapsedTime :=GetTickCount() - AppStart;      // Calculate Elapsed Time
  ElapsedTime :=(LastTime + ElapsedTime) DIV 2; // Average it out for smoother movement

  glDraw();                         // Draw the scene
  SwapBuffers(DC);                  // Display the scene
end;


{------------------------------------------------------------------}
{  If the panel resizes, reset the GL scene                        }
{------------------------------------------------------------------}
procedure TForm1.Panel1Resize(Sender: TObject);
begin
  glViewport(0, 0, Panel1.Width, Panel1.Height);    // Set the viewport for the OpenGL window
  glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
  glLoadIdentity();                   // Reset View
  gluPerspective(45.0, Panel1.Width/Panel1.Height, 1.0, 500.0);  // Do the perspective calculations. Last value = max clipping depth

  glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
end;


{------------------------------------------------------------------}
{  Monitors all keypress events for the app                        }
{------------------------------------------------------------------}
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
keys[key]:=true;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
{
  if Key = #27 then
    Close;

  if (Key= 'w') or (Key='W') then
   begin
    PlayerX:=PlayerX+WalkSpeed*sin(PlayerPhi*Pi/180);
    PlayerZ:=PlayerZ+WalkSpeed*cos(PlayerPhi*Pi/180);
   end;

  if (Key= 'd') or (Key='D') then
   begin
    PlayerPhi:=PlayerPhi-RotateSpeed;
   end;

  if (Key= 'a') or (Key='A') then
   begin
    PlayerPhi:=PlayerPhi+RotateSpeed;
   end;

 }

end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
keys[key]:=false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

end.
